"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
exports.__esModule = true;
var graphql_sequelize_1 = require("graphql-sequelize");
function countResolver(model, schemaDeclaration, globalPreCallback) {
    var _this = this;
    var countResolver = schemaDeclaration.count && schemaDeclaration.count.resolver
        ? schemaDeclaration.count.resolver
        : undefined;
    if (countResolver) {
        return countResolver;
    }
    var listBefore = schemaDeclaration.list && schemaDeclaration.list.before
        ? schemaDeclaration.list.before
        : undefined;
    // Count uses the same before function as the list, except if specified otherwise
    var countBefore = schemaDeclaration.count && schemaDeclaration.count.before
        ? schemaDeclaration.count.before
        : listBefore;
    return function (source, args, context, info) { return __awaiter(_this, void 0, void 0, function () {
        var beforeList, beforeList_1, beforeList_1_1, before, handle, e_1_1, handle, countOptions;
        var e_1, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!schemaDeclaration.before) return [3 /*break*/, 8];
                    beforeList = schemaDeclaration.before;
                    typeof schemaDeclaration.before.length !== 'undefined'
                        ? schemaDeclaration.before
                        : [schemaDeclaration.before];
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 6, 7, 8]);
                    beforeList_1 = __values(beforeList), beforeList_1_1 = beforeList_1.next();
                    _b.label = 2;
                case 2:
                    if (!!beforeList_1_1.done) return [3 /*break*/, 5];
                    before = beforeList_1_1.value;
                    handle = globalPreCallback('listGlobalBefore');
                    return [4 /*yield*/, before(args, context, info)];
                case 3:
                    _b.sent();
                    if (handle) {
                        handle();
                    }
                    _b.label = 4;
                case 4:
                    beforeList_1_1 = beforeList_1.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_1_1 = _b.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (beforeList_1_1 && !beforeList_1_1.done && (_a = beforeList_1["return"])) _a.call(beforeList_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 8:
                    if (!(typeof countBefore !== 'undefined')) return [3 /*break*/, 10];
                    handle = globalPreCallback('countBefore');
                    return [4 /*yield*/, countBefore(graphql_sequelize_1.argsToFindOptions["default"](args, Object.keys(model.rawAttributes)), args, context, info)];
                case 9:
                    countOptions = _b.sent();
                    if (handle) {
                        handle();
                    }
                    return [2 /*return*/, model.count(countOptions)];
                case 10: return [2 /*return*/, model.count(graphql_sequelize_1.argsToFindOptions["default"](args, Object.keys(model.rawAttributes)))];
            }
        });
    }); };
}
exports["default"] = countResolver;
